import { ChainInfo as GrpcChainInfo } from '../../types/rpc_pb';
import { Amount } from '@herajs/common';
export interface ChainId {
    magic: string;
    public: boolean;
    mainnet: boolean;
    consensus: string;
}
export default class ChainInfo {
    chainid: ChainId;
    bpnumber: number;
    maxblocksize: number;
    maxtokens: Amount;
    stakingminimum: Amount;
    stakingtotal: Amount;
    gasprice: Amount;
    nameprice: Amount;
    totalvotingpower: Amount;
    votingreward: Amount;
    constructor(data: Partial<ChainInfo>);
    static fromGrpc(grpcObject: GrpcChainInfo): ChainInfo;
    toGrpc(): never;
}
